include IntelliJ::Helpers
require 'json'

module IntelliJ
  module Install
    def self.included(base)
      base.extend self
    end

    def summarize_release(params)
      source = params.source
      checksum = params.checksum
      version = params.version

      unless params.source
        release = get_release_data(params.version, params.edition)
        version = release['version']
        source, checksum = get_release_download_info(release)
      end

      [source, checksum, version]
    end

    def intellij_installed?(path)
      ::File.exist?("#{path}/build.txt")
    end

    def get_local_intellij_info(path)
      result = nil
      file = "#{path}/product-info.json"
      if ::File.exist?(file)
        info = JSON.parse(::File.read(file))
        result = [info['version'], info['productCode']]
      end
      result
    end
  end
end
