resource_name :intellij_plugin
default_action :install

property :plugin_name, String, name_property: true
property :workspace, String, required: true
property :source, String
property :update, Integer
property :edition, Symbol, equal_to: [:ultimate, :community], default: :community
property :user, String
property :group, String

include IntelliJ::Plugins

action :install do
  begin
    args = @new_resource
    source = args.source || get_default_source(args.plugin_name, args.edition, args.update)
    repo = format(node['intellij']['plugin']['local_repository'], workspace: args.workspace)
    path = "#{repo}/#{::File.basename(URI.parse(source).path)}"

    directory repo do
      recursive true
      user args.user
      group args.group
    end

    remote_file path do
      source source
      user args.user
      group args.group
    end

    if ::File.extname(path) == '.zip'
      zipfile path do
        into repo
        overwrite true
      end

      file path do
        action :delete
      end
    end
  end
end
