resource_name :intellij_run_configuration
default_action :create

property :project_path, String, required: true
property :config_name, String, name_property: true
property :type, String, required: true
property :factory, String, required: true
property :folder, String
property :body, String, required: true
property :user, String
property :group, String

include IntelliJ::Workspace::RunConfiguration
include IntelliJ::Helpers

action :create do
  begin
    args = @new_resource
    xml = generate_run_config_xml(args.config_name, args.type, args.factory, args.folder, args.body)

    file = format(node['intellij']['project']['config']['workspace'], path: args.project_path)

    create_missing_file(file, 'project/workspace.xml', args.user, args.group)
    create_missing_component('RunManager', file)

    xml_edit file do
      parent '/project/component[@name="RunManager"]'
      target "/project/component[@name=\"RunManager\"]/configuration[@name=\"#{args.config_name}\"]"
      fragment xml
      action :append_if_missing
    end
  end
end

action :delete do
  begin
    args = @new_resource
    file = format(node['intellij']['project']['config']['workspace'], path: args.project_path)

    xml_edit file do
      target "/project/component[@name=\"RunManager\"]/configuration[@name=\"#{args.config_name}\"]"
      action :remove
      only_if { ::File.exist?(file) }
    end
  end
end
