require 'spec_helper'
require_relative '../../../../intellij/libraries/plugin'

describe 'intellij_plugin' do
  let(:chef_conf) { ChefSpec::SoloRunner.new step_into: %w(intellij_plugin) }
  let(:workspace_path) { '/home/user/myworkspace' }
  let(:user) { 'myuser' }
  let(:group) { 'mygroup' }

  describe 'testing the resource' do
    context 'installing the plugin' do
      let(:chef_run) { chef_conf.converge('test_intellij::plugin_install') }

      it 'converges successfully' do
        expect { chef_run }.to_not raise_error
      end

      it 'installs the plugin' do
        expect(chef_run).to create_directory("#{workspace_path}/config/plugins").with(user: user, group: group)
        expect(chef_run).to create_remote_file("#{workspace_path}/config/plugins/plugin.zip").with(user: user, group: group)
        expect(chef_run).to extract_zipfile("#{workspace_path}/config/plugins/plugin.zip")
        expect(chef_run).to delete_file("#{workspace_path}/config/plugins/plugin.zip")
      end
    end
  end

  describe 'testing the plugin library' do
    before do
      class PluginsLibrary
        include IntelliJ::Plugins
      end
    end
  end
end
